﻿Type=Class
Version=2.65
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mTarget As Object
    Private mEventName As String
	Private mBase As Panel
	Private StringCanv As Canvas
	Private ChordOLay As Panel
	Private ChordCanv As Canvas
	
	Dim YTopBorder,YBottomBorder As Int
	Dim XBorder As Int
	Dim StringPlaceWidth As Float
	Dim FretHeight As Float
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (TargetModule As Object, EventName As String)
	mTarget = TargetModule
    mEventName = EventName
End Sub
Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)

	mBase = Base
	
	'Set the background colour
	mBase.Color=Colors.White
	
	'Set up Canvases and Overlay Panel
	StringCanv.Initialize(mBase)
	ChordOLay.Initialize("")
	Base.AddView(ChordOLay,0,0,100%x,100%y)
	ChordCanv.Initialize(ChordOLay)
	
	'Draw Strings
	Dim StringHeight As Int = StringCanv.MeasureStringHeight("A",Typeface.DEFAULT,20)

	YBottomBorder = (Base.Height/100)*10
	YTopBorder = YBottomBorder+StringHeight
	XBorder = 0
	StringPlaceWidth = Base.Width/6
	FretHeight = (Base.Height-(YTopBorder+YBottomBorder))/5
	
	Dim StringDispWidth As Int = 1
	
	For i = 0 To 5
		Dim XPos As Float = (i*StringPlaceWidth)+(StringPlaceWidth/2)
		StringCanv.DrawLine(XPos,YTopBorder,XPos,Base.Height-YBottomBorder,Colors.Black,StringDispWidth)
	Next
	
	'Draw Frets
	For i = 0 To 5
		Dim YPos As Float = (i*FretHeight)+YTopBorder
		StringCanv.DrawLine(StringPlaceWidth/2,YPos,Base.Width-StringPlaceWidth/2,YPos,Colors.Black,StringDispWidth)
	Next
	
End Sub
'Get/Set property visible
Sub setVisible(Visible As Boolean)
	mBase.Visible=Visible
End Sub
Sub getVisible As Boolean
	Return mBase.Visible
End Sub
'Draw a chord, requires Chord Name and Array of strings showing fret number
'Currently only shows on first 5 frets.
Sub DrawChord(Name As String,Chord() As String)

	'Clear the canvas
	ChordCanv.DrawColor(Colors.Transparent)

	Dim X,Y As Float
	X=(mBase.Width-ChordCanv.MeasureStringWidth(Name,Typeface.DEFAULT,16))/2
	Y=YBottomBorder
	ChordCanv.DrawText(Name,X,Y,Typeface.DEFAULT,16,Colors.Black,"LEFT")

	For i = 0 To Chord.Length-1
		If Chord(i).ToLowerCase <> "x" Then
			'Draw Open Strings
			X = (i*StringPlaceWidth)+(StringPlaceWidth/2)
			If Chord(i) = 0 Then 
				Y = YTopBorder
				ChordCanv.DrawText("O",X,Y,Typeface.DEFAULT_BOLD,16,Colors.Blue,"CENTER")
			Else
				'Draw Fingerings
				Y=((Chord(i)-1)*FretHeight)+(FretHeight/2)+YTopBorder
				ChordCanv.DrawCircle(X,Y,FretHeight/4,Colors.Blue,True,1)
			End If
			
		Else
			'Draw Muted Strings
			X = (i*StringPlaceWidth)+(StringPlaceWidth/2)
			Y = YTopBorder
			ChordCanv.DrawText("X",X,Y,Typeface.DEFAULT_BOLD,16,Colors.Blue,"CENTER")
		End If
	Next
	ChordOLay.Invalidate
End Sub